local AddonName, zrMM = ...

zrMM.name = AddonName
zrMM.playerName = UnitName("player")


-- Create ui parent
zrMM.border = 2
zrMM.media = {
	flat = "Interface\\Buttons\\WHITE8x8",
	font = "fonts\\FRIZQT__.ttf",
	med_font = CreateFont("zrMM_FONT_MEDIUM"),
	sm_font = CreateFont("zrMM_FONT_SMALL")
}

zrMM.media.med_font:SetFont(zrMM.media.font, 13, "OUTLINE")
zrMM.media.med_font:SetShadowColor(0, 0, 0)
zrMM.media.med_font:SetShadowOffset(0, 0)

zrMM.media.sm_font:SetFont(zrMM.media.font, 10, "OUTLINE")
zrMM.media.sm_font:SetShadowColor(0, 0, 0)
zrMM.media.sm_font:SetShadowOffset(0, 0)

local function createCommands()
	-- /zrmm to open settings
	SLASH_ZRMM_SETTINGS1 = '/zrmm'
	SlashCmdList["ZRMM_SETTINGS"] = function(msg)
		zrSettings:Show()
	end
	-- /rl to reload
	SLASH_ZRMM_RELOAD1 = '/rl'
	SlashCmdList["ZRMM_RELOAD"] = function(msg)
		ReloadUI()
	end
	
end


-- load config
zrMM.loader = CreateFrame("frame", nil, UIParent)
zrMM.loader:RegisterEvent("ADDON_LOADED")
zrMM.loader:SetScript("OnEvent", function(self, event, addon)
	if (addon == zrMM.name) then
		zrMM.loader:UnregisterEvent("ADDON_LOADED")
		if _G["ZRMM_SAVE"] == nil then
			_G["ZRMM_SAVE"] = zrMM.defconfig
		end
		zrMM.config = _G["ZRMM_SAVE"]
		
		-- check saved variables against defaults for missing variables
		for di,dv in pairs(zrMM.defconfig) do
			if not zrMM.config[di] then 
				zrMM.config[di] = dv
			end
		end

		
		
		--debug: the following line sets config to always load defaults, bypassing the saved variables
		--zrMM.config = zrMM.defconfig
		zrMM:loadUITweaks()
		zrMM:CreateSettingsWindow()
		zrMM:CreateMinimap()
		zrMM:CreateButtonFrame()
		zrMM:ApplyConfig()
		createCommands()
		
		
	end
	
	
end)



