local addonName, zrMM = ...

function zrMM:CreateMinimap()
	Minimap:ClearAllPoints()
	Minimap:SetPoint(zrMM.config.mm.point, UIParent, zrMM.config.mm.relativePoint, zrMM.config.mm.xOfs, zrMM.config.mm.yOfs)
	zrMM:set_backdrop(Minimap,1)
	Minimap:SetMovable(true)
	Minimap:EnableMouse(true)
	Minimap:SetSize(zrMM.config.size, zrMM.config.size)
	Minimap:SetMaskTexture(zrMM.media.flat)
	
	Minimap:RegisterEvent("ADDON_LOADED")
	Minimap:RegisterEvent("PLAYER_ENTERING_WORLD")
	Minimap:RegisterEvent("LOADING_SCREEN_DISABLED")
	Minimap:EnableMouseWheel(true)
	
	Minimap:SetScript('OnMouseWheel', function(self, delta)
		local action = delta > 0 and MinimapZoomIn:Click()
		local action = delta < 0 and MinimapZoomOut:Click()
	end)

	Minimap:SetScript('OnMouseDown', function(self, button)
	    if (button == "RightButton") then
			if zrMM.config.lock == false then
				Minimap:StartMoving()
			end
		end
    end)
	
	Minimap:SetScript('OnMouseUp', function(self, button)
		if (button == "LeftButton") then
		    Minimap_OnClick(self)
		elseif (button == "RightButton") then
			if zrMM.config.lock == false then
				Minimap:StopMovingOrSizing()
				zrMM.config.mm.point, parent, zrMM.config.mm.relativePoint, zrMM.config.mm.xOfs, zrMM.config.mm.yOfs = Minimap:GetPoint()
			end
		end
		
		
	end)
	
	local frames = {
		"MiniMapWorldMapButton",
		"MinimapZoneTextButton",
		"MiniMapMailBorder",
		"MiniMapInstanceDifficulty",
		"MinimapNorthTag",
		"MinimapZoomOut",
		"MinimapZoomIn",
		"MinimapBackdrop",
		"GameTimeFrame",
		"GuildInstanceDifficulty",
		"MiniMapChallengeMode",
		"MinimapBorderTop",
		"MinimapBorder",
		"MiniMapToggleButton",
	}
	for i = 1, #frames do
		if (_G[frames[i]]) then
			_G[frames[i]]:Hide()
			_G[frames[i]].Show = noop
		end
	end

	MinimapCluster:EnableMouse(false)
	MiniMapMailIcon:SetTexture(nil)
	MiniMapMailFrame.mail = MiniMapMailFrame:CreateFontString(nil,"OVERLAY")
	MiniMapMailFrame.mail:SetFontObject("zrMM_FONT_MEDIUM")
	MiniMapMailFrame.mail:SetText("M")
	MiniMapMailFrame.mail:SetJustifyH("CENTER")
	MiniMapMailFrame.mail:SetPoint("CENTER", MiniMapMailFrame, "CENTER", 1, -1)
	MiniMapMailFrame:RegisterEvent("UPDATE_PENDING_MAIL")
	MiniMapMailFrame:RegisterEvent("MAIL_INBOX_UPDATE")
	MiniMapMailFrame:RegisterEvent("MAIL_CLOSED")
	MiniMapMailBorder:Hide()

	if not IsAddOnLoaded("Blizzard_TimeManager") then
		LoadAddOn('Blizzard_TimeManager')
	end
	select(1, TimeManagerClockButton:GetRegions()):Hide()
	TimeManagerClockButton:ClearAllPoints()
	TimeManagerClockButton:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT",5,-2)
	TimeManagerClockTicker:SetFontObject("zrMM_FONT_MEDIUM")
	TimeManagerClockTicker:SetAllPoints(TimeManagerClockButton)
	TimeManagerClockTicker:SetJustifyH('LEFT')
	TimeManagerClockTicker:SetShadowColor(0,0,0,0)
	TimeManagerClockTicker:SetShown(zrMM.config.clock)

	TicketStatusFrame:ClearAllPoints()
	TicketStatusFrame:SetPoint("TOP", UIParent, "TOP", 0, -20)

	-- Zone Text
	Minimap.zone = CreateFrame("frame", nil, Minimap)
	Minimap.zone:Hide()
	Minimap.zone.text = Minimap.zone:CreateFontString(nil)
	Minimap.zone.text:SetFontObject("zrMM_FONT_MEDIUM")
	Minimap.zone.text:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 8, -8)
	Minimap.zone.text:SetJustifyH("LEFT")
	Minimap.zone.subtext = Minimap.zone:CreateFontString(nil)
	Minimap.zone.subtext:SetFontObject("zrMM_FONT_MEDIUM")
	Minimap.zone.subtext:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 8, -24)
	Minimap.zone.subtext:SetJustifyH("RIGHT")
	Minimap.zone:RegisterEvent("ZONE_CHANGED")
	Minimap.zone:RegisterEvent("ZONE_CHANGED_INDOORS")
	Minimap.zone:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	Minimap.zone:RegisterEvent("PLAYER_ENTERING_WORLD")
	Minimap.zone:SetScript("OnEvent", function(self, event)
		Minimap.zone.text:SetText(GetZoneText())
		Minimap.zone.subtext:SetText(GetSubZoneText())
	end)
	function zrMM:ZoneTextVisibility()
		if (zrMM.config.zonetext == false) then
			Minimap:SetScript("OnEnter", function()
				Minimap.zone:Show()
			end)
			Minimap:SetScript("OnLeave", function()
				Minimap.zone:Hide()
			end)
		else
			Minimap:SetScript("OnEnter",nil)
			Minimap:SetScript("OnLeave",nil)
			Minimap.zone:Show()
		end
	end
	zrMM:ZoneTextVisibility()

end


